;###################################################################################
;hier werden die ersten 4 bit abgeglichen

;in r16,r17 is the executable code stored, VPC points to it (relativ)
;r18->r21 are local needed registers
.def lower=r17    ;
.def higher=r16   ;

.equ Vsegment=$80 ;here static, but later it will be organised automaticly
.equ SREG =$3f    ;
.cseg       
.org 0x00
.db "_",0
.macro addw ;@0,@1,@2,@3 @0->s1high,summhigh , @1->s1low,summlow @2->s2high @3->s2low
push r16
mov r16, @1
add r16, @3
mov @1, r16
mov r16,@0
adc r16, @2
mov @0, r16
pop r16
.endmacro
;
;offset  head
; 0-1    VSTACKPOINTER HIGH-LOW 
; 2      VSREG    
; 3-5    VPC  max prog size 16Mb
; 6-38   Virtual registers   


clr r27
clr r26
ldi r26,low(Vsegment+6)
ldi r27,high(Vsegment+6)



tut:
sbrc r17,7
rjmp low17
rjmp low07

low17:             ;****
sbrc r17,6
rjmp low1617
rjmp low0617

low1617:           ;***
sbrc r17,5
rjmp low151617
rjmp low051617

low151617:         ;**
sbrc r17,4
rjmp low14151617
rjmp low04151617

low14151617: ;1111
;all branch statements, &bst

low04151617: ;1110

low051617:         ;**
sbrc r17,4
rjmp low14051617
rjmp low04051617

low14051617: ;1101
low04051617: ;1100
;RJMP Statement
mov r18,r16
mov r19,r17
andi r18,0x0f
ldi r26,Vsegment+5
ldi r27,Vsegment+4
ld r21,X+
ld r20,X
addw r21,r20,r18,r19 
st X+,r20
st X,r21
jmp ende

low0617:             ;***
sbrc r17,5
rjmp low150617
rjmp low050617


low150617:            ;**
sbrc r17,4
rjmp low14150617
rjmp low04150617

low14150617:  ;1101
low04150617:  ;0101


low050617:            ;**
sbrc r17,4
rjmp low14050617
rjmp low04050617

low14050617:   ;1001
low04050617:   ;0001
;CP

low07:                ;****
sbrc r17,6
rjmp low1607
rjmp low0607

low1607:              ;***
sbrc r17,5
rjmp low151607
rjmp low051607

low151607:             ;**
sbrc r17,4
rjmp low14151607
rjmp low04151607

;ANDI & cbr statement
low14151607:    ;0111 
;example:
;r16=70 ,r17=0F
;hex code: 0F 70 is 00001111 01110000 swaped 01110000 00001111
;andi opcode is 0111 KKKK dddd KKKK K-> 00001111=> 128 d-> 0000 =>r16
; ==> andi r16,0x0f
ldi r19,$00     
mov r18,r17
andi r18,0xf0
swap r18
;register starts @ r16 so r18+16(15)
ldi r20,0x0f
add r18,r16
addw r27,r26,r19,r18  ; calculate relative pos, Rd
push r18
mov r19,r17
mov r18,r16
andi r19,0x0f
andi r18,0x0f
swap r19
and  r19,r19
pop r18
push r16

ld r16,X              
and r16,r18 ;->andi
st X,r16

ldi r26,low(Vsegment+2)
ldi r27,high(Vsegment+2)
ldi r16,SREG
st X,r16

ldi r26,Vsegment+5
ldi r27,Vsegment+4
ld r16,X
ldi r17,1
add r16,r17
st X,r16

pop r16
jmp ende
;ENDANDI&CBR


low04151607:    ;0110
;SBR ORI statement
;r16=60 ,r17=0F
;hex code: 0F 50 is 00001111 01100000 swaped 01100000 00001111
;sbr,ori opcode is 0110 KKKK dddd KKKK K-> 00001111=> 128 d-> 0000 =>r16
; ==> sbr,Ori r16,0x0f
ldi r19,$00     
mov r18,r17
andi r18,0xf0
swap r18
;register starts @ r16 so r18+16(15)
ldi r20,0x0f
add r18,r16
addw r27,r26,r19,r18  ; calculate relative pos, Rd
push r18
mov r19,r17
mov r18,r16
andi r19,0x0f
andi r18,0x0f
swap r19
and  r19,r19
pop r18
push r16

ld r16,X              
OR r16,r18 ;->SBR, ORI
st X,r16

ldi r26,low(Vsegment+2)
ldi r27,high(Vsegment+2)
ldi r16,SREG
st X,r16

ldi r26,Vsegment+5
ldi r27,Vsegment+4
ld r16,X
ldi r17,1
add r16,r17
st X,r16

pop r16
jmp ende



low051607:             ;**
sbrc r17,4
rjmp low14051607
rjmp low04051607

low14051607:     ;0101
;SUBI statement
;example:
;r16=50 ,r17=0F
;hex code: 0F 50 is 00001111 01010000 swaped 01010000 00001111
;subi opcode is 0101 KKKK dddd KKKK K-> 00001111=> 128 d-> 0000 =>r16
; ==> subi r16,0x0f
ldi r19,$00
mov r18,r17
andi r18,0xf0
swap r18
;register starts for subi @ r16 so r18+16(15)
ldi r20,0x0f
add r18,r16
addw r27,r26,r19,r18  ; calculate relative pos, Rd
push r18
mov r19,r17
mov r18,r16
andi r19,0x0f
andi r18,0x0f
swap r19
and  r19,r18
pop r18
push r16

ld r16,X              
sub r16,r19 ;->subi
st X,r16

ldi r26,low(Vsegment+2)
ldi r27,high(Vsegment+2)
ldi r16,SREG
st X,r16

ldi r26,Vsegment+5
ldi r27,Vsegment+4
ld r16,X
ldi r17,1
add r16,r17
st X,r16

pop r16
jmp ende
;ENDSUBI


low04051607:     ;0100

low0607:                ;***
sbrc r17,5
rjmp low150607
rjmp low050607

low150607:              ;**
sbrc r17,4
rjmp low14150607
rjmp low04150607

low14150607:      ;0011
;CPI statement
;example:
;r16=30 ,r17=0F
;hex code: 0F 30 is 00001111 00110000 swaped 00110000 00001111
;subi opcode is 0011 KKKK dddd KKKK K-> 00001111=> 128 d-> 0000 =>r16
; ==> cpi r16,0x0f
ldi r19,$00
mov r18,r17
andi r18,0xf0
swap r18
;register starts for subi @ r16 so r18+16(15)
ldi r20,0x0f
add r18,r16
addw r27,r26,r19,r18  ; calculate relative pos, Rd
push r18

mov r19,r17
mov r18,r16
andi r19,0x0f
andi r18,0x0f
swap r19
and  r19,r18
pop r18
push r16

ld r16,X
CP r16,r19
st X,r16

ldi r26,low(Vsegment+2)
ldi r27,high(Vsegment+2)
ldi r16,SREG
st X,r16

ldi r26,low(Vsegment+2)
ldi r27,high(Vsegment+2)
ldi r16,SREG
st X,r16

ldi r26,Vsegment+5
ldi r27,Vsegment+4
ld r16,X
ldi r17,1
add r16,r17
st X,r16

pop r16
jmp ende


low04150607:      ;0010



low050607:                ;**
sbrc r17,4
rjmp low14050607  
rjmp low04050607

low14050607:    ;0001
;ROL,ROR
low04050607:    ;0000
;CPC,SBC 


ende: rjmp ende;
      

